﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 키워드 리스트 딕셔너리
    /// </summary>
    public class KeywordListDictionary : Dictionary<string, KeywordList>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 항목 추가하기 - AddItem(keyword)

        /// <summary>
        /// 항목 추가하기
        /// </summary>
        /// <param name="keyword">키워드</param>
        public void AddItem(Keyword keyword)
        {
            if(ContainsKey(keyword.Text))
            {
                KeywordList keywordList = this[keyword.Text];

                keywordList.Add(keyword);
            }
            else
            {
                KeywordList keywordList = new KeywordList();

                keywordList.Add(keyword);

                Add(keyword.Text, keywordList);
            }
        }

        #endregion
        #region 항목 지우기 - RemoveItem(keyword)

        /// <summary>
        /// 항목 지우기
        /// </summary>
        /// <param name="keyword">키워드</param>
        public void RemoveItem(Keyword keyword)
        {
            if(ContainsKey(keyword.Text))
            {
                KeywordList keywordList = this[keyword.Text];

                keywordList.Clear();

                Remove(keyword.Text);
            }            
        }

        #endregion
        #region 데이터 지우기 - ClearData()

        /// <summary>
        /// 데이터 지우기
        /// </summary>
        public void ClearData()
        {
            foreach(KeyValuePair<string, KeywordList> keyValuePair in this)
            {
                KeywordList keywordList = keyValuePair.Value;

                keywordList.Clear();
            }

            Clear();
        }

        #endregion
    }
}